SystemOrganization addCategory: #CommonTraits!
SystemOrganization addCategory: #'CommonTraits-Announcement'!
SystemOrganization addCategory: #'CommonTraits-Metacello'!
SystemOrganization addCategory: #'CommonTraits-Compare'!
SystemOrganization addCategory: #'CommonTraits-Compare-Test'!

Trait named: #TAnnouncer
	uses: {}
	category: 'CommonTraits-Announcement'!

!TAnnouncer commentStamp: 'SantiagoBragagnolo 11/12/2012 10:32' prior: 0!
Just a delagate to get the tipical behavior that should show an object which let you know announcements . (Instead of getting it behavior from an inheritance)!

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
announce: anAnnouncement 
	self resolveAnnouncer announce:anAnnouncement.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
announcer
	self required.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
announcer: anAnnouncer
	self required.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
removeSubscription: subscription
	^self resolveAnnouncer removeSubscription: subscription.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 12/18/2012 12:08'!
resolveAnnouncer
	| announcer | 
	self announcer ifNil: [
		self announcer: Announcer new.	
		self announcer weak.
	].
	^ self announcer.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:34'!
subscribe: aAnnouncement do: aBlock
	^self resolveAnnouncer subscribe: aAnnouncement do: aBlock! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:34'!
subscribe: anAnnouncementClass send: aSelector to: anObject
	^self resolveAnnouncer subscribe: anAnnouncementClass send: aSelector to: anObject.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:34'!
unsubscribe: anObject
	^self resolveAnnouncer unsubscribe: anObject.! !

Trait named: #TConfigurationOf
	uses: {}
	category: 'CommonTraits-Metacello'!

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:45'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:45'!
ensureMetacello
	"Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
	 Gofer API), then load the latest version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [ | error |
		"list of repositories to try, in case primary repository is not accessible"
		(Array 
			with: 'http://www.squeaksource.com/MetacelloRepository' 
			with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
				([
					Smalltalk at: #Gofer ifAbsent: [
					"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
						self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
					Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
						gofer := goferClass new
							url: repositoryUrl;
							yourself.
						[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
						gofer load ]]
							on: Error
							do: [ :ex |
								error := ex.
								Transcript 
									cr; 
									show: 'failed ensureMetacello: ';
									show: ex description printString;
									show: '...retrying'.
								"try again"
								ex return: nil ]) ~~ nil
					ifTrue: [
						"load 'default' group of Metacello"
						(Smalltalk at: #ConfigurationOfMetacello) perform: #load.
						^self ]].
		"shouldn't get here unless the load failed ... throw an error"
		self error: 'retry with alternate repository failed: ', error description printString ]! !

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:45'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:47'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	self lastVersionLoad == nil ifTrue: [ self lastVersionLoad: nil -> 'default' ].
	^self lastVersionLoad! !

!TConfigurationOf classSide methodsFor: 'should implement' stamp: 'SantiagoBragagnolo 12/18/2012 11:48'!
lastVersionLoad 
	"getter"
	self shouldBeImplemented ! !

!TConfigurationOf classSide methodsFor: 'should implement' stamp: 'SantiagoBragagnolo 12/18/2012 11:48'!
lastVersionLoad: aVersion
	"setter"
	self shouldBeImplemented ! !

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:46'!
load
	"self load"

	^self project latestVersion load! !

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:46'!
loadBleedingEdge
	(self project version: #bleedingEdge) load.! !

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:49'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	self lastVersionLoad: versionString -> anArrayOrString! !

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:49'!
project

	^self new project! !

!TConfigurationOf classSide methodsFor: 'base metacello' stamp: 'SantiagoBragagnolo 12/18/2012 11:50'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!TConfigurationOf methodsFor: 'should implement' stamp: 'SantiagoBragagnolo 12/18/2012 11:48'!
getProject 
	"getter"
	self shouldBeImplemented.! !

!TConfigurationOf methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 12/18/2012 11:45'!
project
	
	^self getProject ifNil: [
		 | constructor |
		
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		self setProject: constructor project.
		self getProject loadType: #linear. "change to #atomic if desired"
		self getProject 
	].

! !

!TConfigurationOf methodsFor: 'should implement' stamp: 'SantiagoBragagnolo 12/18/2012 11:48'!
setProject: aProject
	"setter"
	self shouldBeImplemented.! !

Trait named: #TConfigurationOfWithLog
	uses: TConfigurationOf
	category: 'CommonTraits-Metacello'!

TConfigurationOfWithLog classTrait
	uses: TConfigurationOf classTrait!

Trait named: #TEquality
	uses: {}
	category: 'CommonTraits-Compare'!

!TEquality commentStamp: '<historical>' prior: 0!
TEquality is a trait that provides a generic implementation for = and hash.
It aims avoiding to implement = and hash for simple cases.
To make instances of some class comparable, simply make the class use this trait.

TEquality relies on message valuesToCompareForEquality sent to objects for both = and hash.
The default implmentation of this message is provided by Object.
Override ONLY valuesToCompareForEquality method for custom equality check.!

!TEquality methodsFor: 'comparing' stamp: 'NouryBouraqadi 2/4/2011 23:59'!
= anObject 
	self species = anObject species ifFalse: [^false].
	^self valuesToCompareForEquality = anObject valuesToCompareForEquality! !

!TEquality methodsFor: 'comparing' stamp: 'NouryBouraqadi 2/4/2011 18:10'!
hash
	^self valuesToCompareForEquality inject: self species hash into: [:hash :comparisonValue|
		(hash + comparisonValue hash) hashMultiply]
! !

TestCase subclass: #EqualityTest
	instanceVariableNames: 'classFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CommonTraits-Compare-Test'!

!EqualityTest methodsFor: 'setUp-tearDown' stamp: 'NouryBouraqadi 2/4/2011 19:40'!
setUp
	super setUp.
	classFactory := ClassFactoryForTestCase new.
! !

!EqualityTest methodsFor: 'setUp-tearDown' stamp: 'NouryBouraqadi 2/4/2011 19:41'!
tearDown
	super tearDown.
	classFactory cleanUp
! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testSetContainsOnlyOneInstanceOfAClassWithIVs
	| set object class |
	class  := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	class compile: 'x: newX y: newY
		x := newX.
		y := newY'.
	class class compile: 'x: newX y: newY
		^self new
			x: newX y: newY;
			yourself'.
	set := Set new.
	10 timesRepeat: [
		object  := class x: 1 y: 2.
		set add: object].
	self assert: set size = 1.
! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testSetContainsOnlyOneInstanceOfAClassWithNoIVs
	| set |
	set := Set new.
	10 timesRepeat: [set add: ComparableObjectForEqualityTest new].
	self assert: set size = 1.
	self assert: (set includes: ComparableObjectForEqualityTest new)
! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testSetContainsTwoInstancesOfTwoDiffrentClassesWithIVs
	| set otherClass yetAnotherClass |
	otherClass := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	yetAnotherClass := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	{otherClass. yetAnotherClass} do: [:class|
		class compile: 'x: newX y: newY
			x := newX.
			y := newY'.
		class class compile: 'x: newX y: newY
			^self new
				x: newX y: newY;
				yourself'.
	].
	set := Set with: (otherClass x: 'abc' y: 123) with: (yetAnotherClass x: 'abc' y: 123).
	self assert: set size = 2.
	self assert: (set includes: (otherClass x: 'abc' y: 123)).
	self assert: (set includes: (yetAnotherClass x: 'abc' y: 123)).
! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testSetContainsTwoInstancesOfTwoDiffrentClassesWithNoIVs
	| set otherClass |
	otherClass := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: '' classVariableNames:  ''.
	set := Set with: ComparableObjectForEqualityTest new with: otherClass new.
	self assert: set size = 2.
	self assert: (set includes: ComparableObjectForEqualityTest new).
	self assert: (set includes: otherClass new).

! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testTwoInstancesOfTheSameClassWithDifferentIvValuessAreNOTEqual
	| class |
	class  := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	class compile: 'x: newX y: newY
		x := newX.
		y := newY'.
	class class compile: 'x: newX y: newY
		^self new
			x: newX y: newY;
			yourself'.
	self deny: (class x: 1 y: 'abc') = (class x: 1 y: 'zyx').! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testTwoInstancesOfTheSameClassWithNoIVsAreEqual
	self assert: ComparableObjectForEqualityTest new = ComparableObjectForEqualityTest new
	! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testTwoInstancesOfTheSameClassWithSameIvValuessAreEqual
	| class |
	class  := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	class compile: 'x: newX y: newY
		x := newX.
		y := newY'.
	class class compile: 'x: newX y: newY
		^self new
			x: newX y: newY;
			yourself'.
	self assert: (class x: 1 y: 'abc') = (class x: 1 y: 'abc').! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testTwoInstancesOfTowDifferentClassesWithNoIVsAreNOTEqual
	| otherClass |
	otherClass := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: '' classVariableNames:  ''.
	self deny: otherClass new = ComparableObjectForEqualityTest new! !

Object subclass: #ComparableObjectForEqualityTest
	uses: TEquality
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CommonTraits-Compare-Test'!

ComparableObjectForEqualityTest class
	uses: TEquality classTrait
	instanceVariableNames: ''!
